;GTK+ 2.2 runtime environment setup script, for Inno Setup 4.0.8 with ISPP 1.1 or newer
;ISX homepage: <http://www.wintax.nl/isx>, ISPP homepage: <http://www16.brinkster.com/yackimoff/>
;
;extract all files needed by GTK+ 2 in a folder, keeping the structure and run the script from that
;folder
;
;Made by Jernej Simoncic, <jernej.simoncic@guest.arnes.si>
;
;Note: the GTK+ installation path is stored in Registry, in one of these keys (depends whether GTK+ 2
;was installed by administrator or normal user):
;  HKEY_LOCAL_MACHINE\SOFTWARE\Software\GTK\2.0\Path
;  HKEY_CURRENT_USER\SOFTWARE\Software\GTK\2.0\Path
;If none of these keys exist, you can assume that GTK+ 2 isn't installed.
;The Setup also stores GTK version in registry, in one of these keys:
;  HKEY_LOCAL_MACHINE\SOFTWARE\Software\GTK\2.0\Version
;  HKEY_CURRENT_USER\SOFTWARE\Software\GTK\2.0\Version
;The version number is stored like this: 1.3.0-20020530[-1]
;
;changelog:
;
;20030905 - adapted the GTK+ 1.3 install script for GTK 2.2
;20031018 - save color scheme to default gtkrc
;20031019 - minor fix in gtkrc generation (should only affect people who have different window text
;           and button text colors)

;#pragma SingleQuotes(1)

;GTK+ version (should be in format v.v.v[-yyyymmdd][-x] - x is installer revision)
#define GTKVer='2.2.4'

[Setup]
AppName=GTK+ 2 runtime environment
AppID=WinGTK-2
AppVerName=GTK+ {#= GTKVer} runtime environment
AppPublisher=Tor Lillqvist
AppPublisherURL=http://www.gimp.org/win32/
AppSupportURL=http://www.gimp.org/win32/
;AppUpdatesURL=http://www2.arnes.si/~sopjsimo/gimp/test/
DisableProgramGroupPage=true
DisableDirPage=yes
;AlwaysCreateUninstallIcon=true
LicenseFile=libgpl.rtf
ChangesAssociations=true
WizardImageFile=gtklogo.bmp
WizardSmallImageFile=gtk_small.bmp
CreateAppDir=no
OutputDir=Output\47z
UseSetupLdr=no
Compression=none
InternalCompressLevel=0
MinVersion=4,4

[Types]
Name: full; Description: "Full installation"
Name: compact; Description: "Compact installation"; Flags: iscustom
;Name: custom; Description: "Custom installation"; Flags: iscustom

[Tasks]
Name: gtkrc; Description: "Use current Windows color scheme for programs which use GTK+ 2"; GroupDescription: "Interface"

[Components]
Name: base; Description: "Base"; Types: full compact; Flags: fixed
Name: loc; Description: "Translations (some may be incomplete)"; Types: full
#if 0
;TODO
Name: loc\az; Description: "Azerbaijani"; Types: full custom
Name: loc\ca; Description: "Catalan"; Types: full custom
Name: loc\de; Description: "German"; Types: full custom
Name: loc\eu; Description: "Basque"; Types: full custom
Name: loc\ga; Description: "Irish"; Types: full custom
Name: loc\hr; Description: "Croatian"; Types: full custom
Name: loc\ja; Description: "Japanese"; Types: full custom
Name: loc\lv; Description: "Latvian"; Types: full custom
Name: loc\ms; Description: "Malay"; Types: full custom
Name: loc\pl; Description: "Polish"; Types: full custom
Name: loc\ru; Description: "Russian"; Types: full custom
Name: loc\sr; Description: "Serbian"; Types: full custom
Name: loc\tr; Description: "Turkish"; Types: full custom
Name: loc\yi; Description: "Yiddish"; Types: full custom
Name: loc\be; Description: "Belarusian"; Types: full custom
Name: loc\cs; Description: "Czech"; Types: full custom
Name: loc\el; Description: "Greek"; Types: full custom
Name: loc\fa; Description: "Persian"; Types: full custom
Name: loc\gl; Description: "Gallegan"; Types: full custom
Name: loc\hu; Description: "Hungarian"; Types: full custom
Name: loc\ko; Description: "Korean"; Types: full custom
Name: loc\mk; Description: "Macedonian"; Types: full custom
Name: loc\nl; Description: "Dutch"; Types: full custom
Name: loc\pt; Description: "Portuguese"; Types: full custom
Name: loc\sk; Description: "Slovak"; Types: full custom
Name: loc\sr@Latn; Description: "Serbian (Latin)"; Types: full custom
Name: loc\uk; Description: "Ukrainian"; Types: full custom
Name: loc\zh_CN; Description: "Chinese (Simplified)"; Types: full custom
Name: loc\zh_TW; Description: "Chinese (Traditional)"; Types: full custom
Name: loc\am; Description: "Amharic"; Types: full custom
Name: loc\bg; Description: "Bulgarian"; Types: full custom
Name: loc\cy; Description: "Welsh"; Types: full custom
Name: loc\es; Description: "Spanish"; Types: full custom
Name: loc\fi; Description: "Finnish"; Types: full custom
Name: loc\he; Description: "Hebrew"; Types: full custom
Name: loc\id; Description: "Indonesian"; Types: full custom
Name: loc\li; Description: "Limburgish"; Types: full custom
Name: loc\ml; Description: "Malayalam"; Types: full custom
Name: loc\nn; Description: "Norwegian Nynorsk"; Types: full custom
Name: loc\pt_BR; Description: "Portuguese (Brazil)"; Types: full custom
Name: loc\sl; Description: "Slovenian"; Types: full custom
Name: loc\sv; Description: "Swedish"; Types: full custom
Name: loc\vi; Description: "Vietnamese"; Types: full custom
Name: loc\ar; Description: "Arabic"; Types: full custom
Name: loc\bn; Description: "Bengali"; Types: full custom
Name: loc\da; Description: "Danish"; Types: full custom
Name: loc\et; Description: "Estonian"; Types: full custom
Name: loc\fr; Description: "French"; Types: full custom
Name: loc\hi; Description: "Hindi"; Types: full custom
Name: loc\it; Description: "Italian"; Types: full custom
Name: loc\lt; Description: "Lithuanian"; Types: full custom
Name: loc\mn; Description: "Mongolian"; Types: full custom
Name: loc\no; Description: "Norwegian"; Types: full custom
Name: loc\ro; Description: "Romanian"; Types: full custom
Name: loc\sq; Description: "Albanian"; Types: full custom
Name: loc\ta; Description: "Tamil"; Types: full custom
Name: loc\wa; Description: "Walloon"; Types: full custom
#endif

[Files]
Source: "bin\*.*"; DestDir: "{code:GetGTKdir|nothing}\bin"; Flags: recursesubdirs; Components: base
Source: "bin\intl.dll"; DestDir: "{code:GetGTKdir|nothing}\bin"; DestName: "libintl-1.dll"; Components: base
Source: "bin\zlib-1.dll"; DestDir: "{code:GetGTKdir|nothing}\bin"; DestName: "zlib.dll"; Components: base
Source: "bin\jpeg-62.dll"; DestDir: "{code:GetGTKdir|nothing}\bin"; DestName: "libjpeg.dll"; Components: base
Source: "etc\*.*"; DestDir: "{code:GetGTKdir|nothing}\etc"; Flags: recursesubdirs; Components: base
Source: "share\*.*"; DestDir: "{code:GetGTKdir|nothing}\share"; Flags: recursesubdirs; Components: base
Source: "lib\gtk-2.0\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\gtk-2.0"; Flags: ignoreversion recursesubdirs; Components: base
Source: "lib\pango\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\pango"; Flags: ignoreversion recursesubdirs; Components: base

Source: "lib\locale\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale"; Flags: ignoreversion recursesubdirs; Components: loc
#if 0
;TODO
Source: "lib\locale\az\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\az"; Flags: ignoreversion recursesubdirs; Components: loc\az
Source: "lib\locale\ca\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\ca"; Flags: ignoreversion recursesubdirs; Components: loc\ca
Source: "lib\locale\de\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\de"; Flags: ignoreversion recursesubdirs; Components: loc\de
Source: "lib\locale\eu\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\eu"; Flags: ignoreversion recursesubdirs; Components: loc\eu
Source: "lib\locale\ga\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\ga"; Flags: ignoreversion recursesubdirs; Components: loc\ga
Source: "lib\locale\hr\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\hr"; Flags: ignoreversion recursesubdirs; Components: loc\hr
Source: "lib\locale\ja\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\ja"; Flags: ignoreversion recursesubdirs; Components: loc\ja
Source: "lib\locale\lv\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\lv"; Flags: ignoreversion recursesubdirs; Components: loc\lv
Source: "lib\locale\ms\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\ms"; Flags: ignoreversion recursesubdirs; Components: loc\ms
Source: "lib\locale\pl\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\pl"; Flags: ignoreversion recursesubdirs; Components: loc\pl
Source: "lib\locale\ru\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\ru"; Flags: ignoreversion recursesubdirs; Components: loc\ru
Source: "lib\locale\sr\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\sr"; Flags: ignoreversion recursesubdirs; Components: loc\sr
Source: "lib\locale\tr\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\tr"; Flags: ignoreversion recursesubdirs; Components: loc\tr
Source: "lib\locale\yi\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\yi"; Flags: ignoreversion recursesubdirs; Components: loc\yi
Source: "lib\locale\be\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\be"; Flags: ignoreversion recursesubdirs; Components: loc\be
Source: "lib\locale\cs\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\cs"; Flags: ignoreversion recursesubdirs; Components: loc\cs
Source: "lib\locale\el\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\el"; Flags: ignoreversion recursesubdirs; Components: loc\el
Source: "lib\locale\fa\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\fa"; Flags: ignoreversion recursesubdirs; Components: loc\fa
Source: "lib\locale\gl\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\gl"; Flags: ignoreversion recursesubdirs; Components: loc\gl
Source: "lib\locale\hu\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\hu"; Flags: ignoreversion recursesubdirs; Components: loc\hu
Source: "lib\locale\ko\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\ko"; Flags: ignoreversion recursesubdirs; Components: loc\ko
Source: "lib\locale\mk\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\mk"; Flags: ignoreversion recursesubdirs; Components: loc\mk
Source: "lib\locale\nl\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\nl"; Flags: ignoreversion recursesubdirs; Components: loc\nl
Source: "lib\locale\pt\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\pt"; Flags: ignoreversion recursesubdirs; Components: loc\pt
Source: "lib\locale\sk\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\sk"; Flags: ignoreversion recursesubdirs; Components: loc\sk
Source: "lib\locale\sr@Latn\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\sr@Latn"; Flags: ignoreversion recursesubdirs; Components: loc\sr@Latn
Source: "lib\locale\uk\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\uk"; Flags: ignoreversion recursesubdirs; Components: loc\uk
Source: "lib\locale\zh_CN\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\zh_CN"; Flags: ignoreversion recursesubdirs; Components: loc\zh_CN
Source: "lib\locale\am\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\am"; Flags: ignoreversion recursesubdirs; Components: loc\am
Source: "lib\locale\bg\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\bg"; Flags: ignoreversion recursesubdirs; Components: loc\bg
Source: "lib\locale\cy\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\cy"; Flags: ignoreversion recursesubdirs; Components: loc\cy
Source: "lib\locale\es\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\es"; Flags: ignoreversion recursesubdirs; Components: loc\es
Source: "lib\locale\fi\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\fi"; Flags: ignoreversion recursesubdirs; Components: loc\fi
Source: "lib\locale\he\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\he"; Flags: ignoreversion recursesubdirs; Components: loc\he
Source: "lib\locale\id\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\id"; Flags: ignoreversion recursesubdirs; Components: loc\id
Source: "lib\locale\li\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\li"; Flags: ignoreversion recursesubdirs; Components: loc\li
Source: "lib\locale\ml\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\ml"; Flags: ignoreversion recursesubdirs; Components: loc\ml
Source: "lib\locale\nn\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\nn"; Flags: ignoreversion recursesubdirs; Components: loc\nn
Source: "lib\locale\pt_BR\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\pt_BR"; Flags: ignoreversion recursesubdirs; Components: loc\pt_BR
Source: "lib\locale\sl\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\sl"; Flags: ignoreversion recursesubdirs; Components: loc\sl
Source: "lib\locale\sv\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\sv"; Flags: ignoreversion recursesubdirs; Components: loc\sv
Source: "lib\locale\vi\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\vi"; Flags: ignoreversion recursesubdirs; Components: loc\vi
Source: "lib\locale\zh_TW\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\zh_TW"; Flags: ignoreversion recursesubdirs; Components: loc\zh_TW
Source: "lib\locale\ar\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\ar"; Flags: ignoreversion recursesubdirs; Components: loc\ar
Source: "lib\locale\bn\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\bn"; Flags: ignoreversion recursesubdirs; Components: loc\bn
Source: "lib\locale\da\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\da"; Flags: ignoreversion recursesubdirs; Components: loc\da
Source: "lib\locale\et\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\et"; Flags: ignoreversion recursesubdirs; Components: loc\et
Source: "lib\locale\fr\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\fr"; Flags: ignoreversion recursesubdirs; Components: loc\fr
Source: "lib\locale\hi\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\hi"; Flags: ignoreversion recursesubdirs; Components: loc\hi
Source: "lib\locale\it\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\it"; Flags: ignoreversion recursesubdirs; Components: loc\it
Source: "lib\locale\lt\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\lt"; Flags: ignoreversion recursesubdirs; Components: loc\lt
Source: "lib\locale\mn\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\mn"; Flags: ignoreversion recursesubdirs; Components: loc\mn
Source: "lib\locale\no\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\no"; Flags: ignoreversion recursesubdirs; Components: loc\no
Source: "lib\locale\ro\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\ro"; Flags: ignoreversion recursesubdirs; Components: loc\ro
Source: "lib\locale\sq\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\sq"; Flags: ignoreversion recursesubdirs; Components: loc\sq
Source: "lib\locale\ta\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\ta"; Flags: ignoreversion recursesubdirs; Components: loc\ta
Source: "lib\locale\wa\*.*"; DestDir: "{code:GetGTKdir|nothing}\lib\locale\wa"; Flags: ignoreversion recursesubdirs; Components: loc\wa
#endif

[Messages]
WelcomeLabel1=Welcome to Setup Wizard for GTK+ 2 runtime environment
AboutSetupNote=Setup built by Jernej Simoncic, jernej.simoncic@guest.arnes.si
SetupLdrStartupMessage=This program will install or update %1. Do you wish to continue?
ConfirmUninstall=This program will uninstall GTK+ 2 runtime environment, on which programs can be dependant. Are you sure you want the uninstall to proceed?

[Registry]
Root: "HKLM"; SubKey: "SOFTWARE\GTK\2.0"; ValueType: string; ValueName: "Path"; ValueData: "{code:GetGTKDir|none}"; Check: AdminCheck(yes); Flags: uninsdeletevalue uninsdeletekeyifempty
Root: "HKLM"; SubKey: "SOFTWARE\GTK\2.0"; ValueType: string; ValueName: "Version"; ValueData: "{#= GTKVer}"; Check: AdminCheck(yes); Flags: uninsdeletevalue uninsdeletekeyifempty
Root: "HKCU"; SubKey: "SOFTWARE\GTK\2.0"; ValueType: string; ValueName: "Path"; ValueData: "{code:GetGTKDir|none}"; Check: AdminCheck(no); Flags: uninsdeletevalue uninsdeletekeyifempty
Root: "HKCU"; SubKey: "SOFTWARE\GTK\2.0"; ValueType: string; ValueName: "Version"; ValueData: "{#= GTKVer}"; Check: AdminCheck(no); Flags: uninsdeletevalue uninsdeletekeyifempty


[Code]
program Setup;

  function GetSysColor(nIndex: Integer): Integer; external 'GetSysColor@user32 stdcall';

  var
    GTKDir: String;
    Warnings: Integer;
    InstallMode: Integer;
    InstPath,InstPathVal: TArrayOfString;

  const
    GTKRegPath = 'SOFTWARE\GTK\2.0';
    RegKey = 'Inno Setup: App Path';

  
  function InitializeSetup(): Boolean;
  var InstVers: String;
      i: Integer;
  begin

    If not RegQueryStringValue(HKLM, GTKRegPath, 'Path', GTKDir) then //find GTK+
      RegQueryStringValue(HKCU, GTKRegPath, 'Path', GTKDir);          //install dir
      
    If not RegQueryStringValue(HKLM, GTKRegPath, 'Version', InstVers) then //get installed GTK version (if any)
      RegQueryStringValue(HKCU, GTKRegPath, 'Version', InstVers);
      
    if InstVers>'{#= GTKVer}' then //newer version of GTK is already installed
    begin
      Warnings:=Warnings or 2;
      Warnings:=Warnings or 1;
    end

    if RegValueExists(HKLM, GTKRegPath, 'Path') and (not IsAdminLoggedOn) then  //if GTK+ was installed by admin
    begin                                                          //previously, don't allow normal user to upgrade
      Warnings:=Warnings or 4;
      Warnings:=Warnings or 1;
    end

    If (not IsAdminLoggedOn) then
      Warnings:=Warnings or 8;

    SetArrayLength(InstPath, 2);    //used for selecting installation path
    SetArrayLength(InstPathVal, 2);
    InstPath[0]:='&Default (recommended)';
    InstPath[1]:='&Custom (for advanced users)';
    InstPathVal[0]:='1';
    InstPathVal[1]:='0';
    
    If ParamCount>0 then //choose the default install dir in silent & very silent setup modes
      for i := 1 to ParamCount do
        if (Uppercase(Copy(ParamStr(i),1,7))='/SILENT') or (Uppercase(Copy(ParamStr(i),1,11))='/VERYSILENT') then
          if GTKDir = '' then
            GTKdir := ExpandConstant('{cf}\GTK\2.0');

    if GTKDir='' then
      InstallMode:=1  //choose GTK dir
    else
      InstallMode:=0; //use previous GTK dir

    Result := True;
  end;


  //GTK+ installation directory (can be called from script like this: {code:GetGTKDir|default} )
  function GetGTKDir(S: String): String;
  begin
    Result := GTKdir;
  end;


  function ScriptDlgPages(CurPage: Integer; BackClicked: Boolean): Boolean;
  var Next, ChooseDir: Boolean;
      CurSubPage: Integer;
      Text: String;
  begin

    if (not BackClicked and (CurPage = wpWelcome)) or (BackClicked and (CurPage = wpLicense)) then
    begin
      //////////////////////////////////////////////
      // Errors (the installation can't continue) //
      //////////////////////////////////////////////
      If Warnings > 0 then begin //display the page only if necessary
        ScriptDlgPageOpen();
        if (Warnings and 1)=1 then
        begin
          ScriptDlgPageSetCaption('Error');
          ScriptDlgPageSetSubCaption1('The Setup encountered an error and cannot continue');
        end else
        begin
          ScriptDlgPageSetCaption('Warning');
          ScriptDlgPageSetSubCaption1('There may be problems with your current configuration');
        end;

        Text := '';
        If (Warnings and 2)=2 then
          Text := Text+'Newer version of GTK+ 2 runtimes is already installed.'#13#13;
        If (Warnings and 4)=4 then
          Text := Text+'It was detected that the Administrator previously installed GTK+ 2 on this computer. Since you don''t have Admin rights you cannot upgrade GTK+.'#13#13;
        If (Warnings and 16)=16 then
          Text := Text+'It is highly recommended that the GTK+ runtime environment is installed by the Administrator. If you encounter any problems, please uninstall GTK and install it again as Administrator.'#13#13;

        Next := OutputMsg(Text,False);
        if (Warnings and 1)=1 then
          exit;

        if not BackClicked then
          Result := Next
        else
          Result := not Next;

        ScriptDlgPageClose(not Result);

      end else begin
        Result := True;
      end;

    end else if (not BackClicked and (CurPage = wpLicense)) or (BackClicked and (CurPage = wpReady)) then
    begin
      ///////////////////////////
      // select GTK+ directory //
      ///////////////////////////
      if InstallMode=1 then
      begin
        ScriptDlgPageOpen();

        if not BackClicked then //decide which page to show
          CurSubPage := 0
        else
          if InstPathVal[0]='0' then
          begin
            CurSubPage := 1;
            ChooseDir:=True;
          end else
            CurSubPage := 0;

        while (CurSubPage>=0) and (CurSubPage<=1) and not Terminated do
        begin
          case CurSubPage of
            0:
            begin

              if IsAdminLoggedOn=False then //must choose install path if not admin
              begin
            
                ChooseDir := True;
                Next := True;

              end else begin

                ScriptDlgPageSetCaption('GTK+ 2 installation folder');
                ScriptDlgPageSetSubCaption1('Where should GTK+ 2 be installed');
	                ScriptDlgPageSetSubCaption2('Should the Setup install the GTK+ 2 runtime environment to the default location, or would you like to specify a custom folder:'#13);
                Next := InputOptionArray(InstPath, InstPathVal, True, False);
              
                if InstPathVal[0]='1' then
                  ChooseDir:=False
                else
                  ChooseDir:=True;

              end;

            end;
            1:
            begin
              if ChooseDir then
              begin
                ScriptDlgPageSetCaption('Select GTK+ 2 Installation directory');
                ScriptDlgPageSetSubCaption1('Where should GTK+ 2 runtime files be installed?');
                ScriptDlgPageSetSubCaption2('Select the folder you would like Setup to install GTK+ 2 runtime files to and click Next.');
                // Initialize the GTKdir if necessary
                if GTKdir = '' then
                  GTKdir := ExpandConstant('{cf}\GTK\2.0');
                // Ask for a dir until the user has entered one or click Back or Cancel
                Next := InputDir('GTK+', GTKdir);
                while Next and (GTKdir = '') do begin
                  MsgBox(SetupMessage(msgInvalidPath), mbError, MB_OK);
                  Next := InputDir('GTK+', GTKdir);
                end;
              end else
              begin
                GTKdir := ExpandConstant('{cf}\GTK\2.0');
                Result := True;
              end;
            end;
            
          end; (*case*)
          
          if Next then
            CurSubPage := CurSubPage + 1
          else
            if IsAdminLoggedOn=True then
              CurSubPage := CurSubPage - 1
            else
              CurSubPage := -1;
            
        end; (*while*)
        
        if not BackClicked then
          Result := Next
        else
          Result := not Next;
          
        ScriptDlgPageClose(not Result);
        
      end else
      begin
        Result := True;
      end;
    end else begin
      Result := True;
    end;
  end;


  function UpdateReadyMemo(Space, NewLine, MemoUserInfo, MemoDirInfo, MemoTypeInfo, MemoComponentsInfo, MemoGroupInfo, MemoTasksInfo: String): String;
  var S: String;
  begin

    (* Fill the 'Ready Memo' with setup information *)

    if InstallMode=0 then
      S := 'GTK+ 2 was found in:' + NewLine + Space + GetGTKDir('')                //installation directory
    else
      S := 'Destination directory:' + NewLine + Space + GetGTKDir('');                //installation directory
      

    Result := S;
  end;


  function NextButtonClick(CurPage: Integer): Boolean;
  begin
    Result := ScriptDlgPages(CurPage, False);
  end;


  function BackButtonClick(CurPage: Integer): Boolean;
  begin
    Result := ScriptDlgPages(CurPage, True);
  end;


  (* convert RGB color to BGR HEX value *)
  function RGBBGR(q: Integer): String;
  var a,b,c: String;
      d,e: Integer;
  begin

    while q>0 do
    begin
      e := (q and 15) + 1;
      a := copy('0123456789ABCDEF', e, 1);
      q := q / 16;
      c := a + b;
      b := c;
    end;

    d:=6-Length(b);
    if d>0 then
    begin
      c := StringOfChar('0',d) + b;
      b := c;
    end;

    a := copy(b,1,2);
    c := copy(b,5,2);
    b := copy(b,3,2);

    Result := c + b + a;
  end;

  procedure CurStepChanged(CurStep: Integer);
  var S,GTKRC: String;
      clBtnFace,clBtnShadow,clBtnLight,clText,clGrayText,clHilight,clHilightText,
      clTooltip,clTooltipText,clWindow,clWindowText: String;
  begin
  	if curStep = csFinished then

      if (ShouldProcessEntry('base','gtkrc')=srYes) then
      begin
        GTKRC := GTKdir + '\etc\gtk-2.0\gtkrc';

        if not FileExists(GTKRC) then //dummy file should be placed there by the installer
          MsgBox('Error: Windows color scheme could not be saved. (This should never happen)',mbInformation,0)
        else
        begin
        
          //get the windows' colors
          clBtnFace := RGBBGR(GetSysColor(15));
          clBtnShadow := RGBBGR(GetSysColor(16));
          clBtnLight := RGBBGR(GetSysColor(20));
          clText := RGBBGR(GetSysColor(18));
          clWindow := RGBBGR(GetSysColor(5));
          clWindowText := RGBBGR(GetSysColor(8));
          clGrayText := RGBBGR(GetSysColor(17));
          clHilight := RGBBGR(GetSysColor(13));
          clHilightText := RGBBGR(GetSysColor(14));
          clTooltip := RGBBGR(GetSysColor(24));
          clTooltipText := RGBBGR(GetSysColor(23));          
          
          S:='#generated by GTK+ 2 install';
          S:=S+#10;
          S:=S+#10'style "default"';
          S:=S+#10'{';
          S:=S+#10'  bg[NORMAL] = "#'+clBtnFace+'"';
          S:=S+#10'  bg[SELECTED] = "#'+clHilight+'"';
          S:=S+#10'  bg[INSENSITIVE] = "#'+clBtnFace+'"';
          S:=S+#10'  bg[ACTIVE] = "#'+clBtnFace+'"';
          S:=S+#10'  bg[PRELIGHT] = "#'+clHilight+'"';
          S:=S+#10'';
          S:=S+#10'  base[NORMAL] = "#'+clWindow+'"';
          S:=S+#10'  base[SELECTED] = "#'+clHilight+'"';
          S:=S+#10'  base[INSENSITIVE] = "#'+clBtnFace+'"';
          S:=S+#10'  base[ACTIVE] = "#'+clBtnFace+'"';
          S:=S+#10'  base[PRELIGHT] = "#'+clWindow+'"';
          S:=S+#10'';
          S:=S+#10'  text[NORMAL] = "#'+clWindowText+'"'; //clText
          S:=S+#10'  text[SELECTED] = "#'+clHilightText+'"';
          S:=S+#10'  text[INSENSITIVE] = "#'+clBtnFace+'"';
          S:=S+#10'  text[ACTIVE] = "#'+clText+'"';
          S:=S+#10'  text[PRELIGHT] = "#'+clWindowText+'"'; //clHilightText
          S:=S+#10'';
          S:=S+#10'  fg[NORMAL] = "#'+clText+'"';
          S:=S+#10'  fg[SELECTED] = "#'+clHilightText+'"';
          S:=S+#10'  fg[INSENSITIVE] = "#'+clGrayText+'"';
          S:=S+#10'  fg[ACTIVE] = "#'+clText+'"';
          S:=S+#10'  fg[PRELIGHT] = "#'+clHilightText+'"';
          S:=S+#10'}';
          S:=S+#10'class "*" style "default"';
          S:=S+#10'';
          S:=S+#10'style "tooltip"';
          S:=S+#10'{';
          S:=S+#10'  bg[NORMAL] = "#'+clTooltip+'"';
          S:=S+#10'  fg[NORMAL] = "#'+clTooltipText+'"';
          S:=S+#10'}';
          S:=S+#10'widget "*gtk-tooltip*" style "tooltip"';
          S:=S+#10'';
          S:=S+#10'style "button" {';
          S:=S+#10'  bg[NORMAL]    = "#'+clBtnFace+'"';
          S:=S+#10'  bg[PRELIGHT]  = "#'+clBtnFace+'"';
          S:=S+#10'  bg[INSENSITIVE] = "#'+clBtnFace+'"';
          S:=S+#10'  fg[PRELIGHT] = "#'+clText+'"';
          S:=S+#10'}';
          S:=S+#10'widget "*Gtk*Button*" style "button"';
          S:=S+#10'';
          S:=S+#10'style "text" {';
          S:=S+#10'  fg[NORMAL] = "#'+clWindowText+'"';
          S:=S+#10'}';
          S:=S+#10'widget_class "*Entry*" style "text"';
          S:=S+#10'widget_class "*Tree*" style "text"';
          S:=S+#10'widget_class "*Text*" style "text"';
          S:=S+#10'widget_class "*GtkSpinButton*" style "text"';
          S:=S+#10'widget_class "*Editable*" style "text"';
          S:=S+#10'widget_class "*Combo*" style "text"';
          S:=S+#10'';

          if not SaveStringToFile(GTKRC,S,False) then
            MsgBox('Error: could not update color scheme file.',mbInformation,0);

        end;

  	end;
  end;
  
  
  function AdminCheck(S: String): Boolean;
  begin
    if S='yes' then
    begin
      if IsAdminLoggedOn then
        Result:=True
      else
        Result:=False;
    end else
    begin
      if IsAdminLoggedOn then
        Result:=False
      else
        Result:=True;
    end;
  end;

begin
end.
